# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DecryptionProfileArgs', 'DecryptionProfile']

@pulumi.input_type
class DecryptionProfileArgs:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 ssl_forward_proxy: Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']] = None,
                 ssl_inbound_proxy: Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']] = None,
                 ssl_no_proxy: Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']] = None,
                 ssl_protocol_settings: Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']] = None):
        """
        The set of arguments for constructing a DecryptionProfile resource.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[str] name: Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input['DecryptionProfileSslForwardProxyArgs'] ssl_forward_proxy: The SslForwardProxy param.
        :param pulumi.Input['DecryptionProfileSslInboundProxyArgs'] ssl_inbound_proxy: The SslInboundProxy param.
        :param pulumi.Input['DecryptionProfileSslNoProxyArgs'] ssl_no_proxy: The SslNoProxy param.
        :param pulumi.Input['DecryptionProfileSslProtocolSettingsArgs'] ssl_protocol_settings: The SslProtocolSettings param.
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if folder is not None:
            pulumi.set(__self__, "folder", folder)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if snippet is not None:
            pulumi.set(__self__, "snippet", snippet)
        if ssl_forward_proxy is not None:
            pulumi.set(__self__, "ssl_forward_proxy", ssl_forward_proxy)
        if ssl_inbound_proxy is not None:
            pulumi.set(__self__, "ssl_inbound_proxy", ssl_inbound_proxy)
        if ssl_no_proxy is not None:
            pulumi.set(__self__, "ssl_no_proxy", ssl_no_proxy)
        if ssl_protocol_settings is not None:
            pulumi.set(__self__, "ssl_protocol_settings", ssl_protocol_settings)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def folder(self) -> Optional[pulumi.Input[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @folder.setter
    def folder(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def snippet(self) -> Optional[pulumi.Input[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @snippet.setter
    def snippet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snippet", value)

    @property
    @pulumi.getter(name="sslForwardProxy")
    def ssl_forward_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']]:
        """
        The SslForwardProxy param.
        """
        return pulumi.get(self, "ssl_forward_proxy")

    @ssl_forward_proxy.setter
    def ssl_forward_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']]):
        pulumi.set(self, "ssl_forward_proxy", value)

    @property
    @pulumi.getter(name="sslInboundProxy")
    def ssl_inbound_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']]:
        """
        The SslInboundProxy param.
        """
        return pulumi.get(self, "ssl_inbound_proxy")

    @ssl_inbound_proxy.setter
    def ssl_inbound_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']]):
        pulumi.set(self, "ssl_inbound_proxy", value)

    @property
    @pulumi.getter(name="sslNoProxy")
    def ssl_no_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']]:
        """
        The SslNoProxy param.
        """
        return pulumi.get(self, "ssl_no_proxy")

    @ssl_no_proxy.setter
    def ssl_no_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']]):
        pulumi.set(self, "ssl_no_proxy", value)

    @property
    @pulumi.getter(name="sslProtocolSettings")
    def ssl_protocol_settings(self) -> Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']]:
        """
        The SslProtocolSettings param.
        """
        return pulumi.get(self, "ssl_protocol_settings")

    @ssl_protocol_settings.setter
    def ssl_protocol_settings(self, value: Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']]):
        pulumi.set(self, "ssl_protocol_settings", value)


@pulumi.input_type
class _DecryptionProfileState:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 ssl_forward_proxy: Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']] = None,
                 ssl_inbound_proxy: Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']] = None,
                 ssl_no_proxy: Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']] = None,
                 ssl_protocol_settings: Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']] = None,
                 tfid: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DecryptionProfile resources.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[str] name: Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input['DecryptionProfileSslForwardProxyArgs'] ssl_forward_proxy: The SslForwardProxy param.
        :param pulumi.Input['DecryptionProfileSslInboundProxyArgs'] ssl_inbound_proxy: The SslInboundProxy param.
        :param pulumi.Input['DecryptionProfileSslNoProxyArgs'] ssl_no_proxy: The SslNoProxy param.
        :param pulumi.Input['DecryptionProfileSslProtocolSettingsArgs'] ssl_protocol_settings: The SslProtocolSettings param.
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if folder is not None:
            pulumi.set(__self__, "folder", folder)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if snippet is not None:
            pulumi.set(__self__, "snippet", snippet)
        if ssl_forward_proxy is not None:
            pulumi.set(__self__, "ssl_forward_proxy", ssl_forward_proxy)
        if ssl_inbound_proxy is not None:
            pulumi.set(__self__, "ssl_inbound_proxy", ssl_inbound_proxy)
        if ssl_no_proxy is not None:
            pulumi.set(__self__, "ssl_no_proxy", ssl_no_proxy)
        if ssl_protocol_settings is not None:
            pulumi.set(__self__, "ssl_protocol_settings", ssl_protocol_settings)
        if tfid is not None:
            pulumi.set(__self__, "tfid", tfid)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def folder(self) -> Optional[pulumi.Input[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @folder.setter
    def folder(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def snippet(self) -> Optional[pulumi.Input[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @snippet.setter
    def snippet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snippet", value)

    @property
    @pulumi.getter(name="sslForwardProxy")
    def ssl_forward_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']]:
        """
        The SslForwardProxy param.
        """
        return pulumi.get(self, "ssl_forward_proxy")

    @ssl_forward_proxy.setter
    def ssl_forward_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslForwardProxyArgs']]):
        pulumi.set(self, "ssl_forward_proxy", value)

    @property
    @pulumi.getter(name="sslInboundProxy")
    def ssl_inbound_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']]:
        """
        The SslInboundProxy param.
        """
        return pulumi.get(self, "ssl_inbound_proxy")

    @ssl_inbound_proxy.setter
    def ssl_inbound_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslInboundProxyArgs']]):
        pulumi.set(self, "ssl_inbound_proxy", value)

    @property
    @pulumi.getter(name="sslNoProxy")
    def ssl_no_proxy(self) -> Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']]:
        """
        The SslNoProxy param.
        """
        return pulumi.get(self, "ssl_no_proxy")

    @ssl_no_proxy.setter
    def ssl_no_proxy(self, value: Optional[pulumi.Input['DecryptionProfileSslNoProxyArgs']]):
        pulumi.set(self, "ssl_no_proxy", value)

    @property
    @pulumi.getter(name="sslProtocolSettings")
    def ssl_protocol_settings(self) -> Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']]:
        """
        The SslProtocolSettings param.
        """
        return pulumi.get(self, "ssl_protocol_settings")

    @ssl_protocol_settings.setter
    def ssl_protocol_settings(self, value: Optional[pulumi.Input['DecryptionProfileSslProtocolSettingsArgs']]):
        pulumi.set(self, "ssl_protocol_settings", value)

    @property
    @pulumi.getter
    def tfid(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "tfid")

    @tfid.setter
    def tfid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tfid", value)


class DecryptionProfile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 ssl_forward_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslForwardProxyArgs', 'DecryptionProfileSslForwardProxyArgsDict']]] = None,
                 ssl_inbound_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslInboundProxyArgs', 'DecryptionProfileSslInboundProxyArgsDict']]] = None,
                 ssl_no_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslNoProxyArgs', 'DecryptionProfileSslNoProxyArgsDict']]] = None,
                 ssl_protocol_settings: Optional[pulumi.Input[Union['DecryptionProfileSslProtocolSettingsArgs', 'DecryptionProfileSslProtocolSettingsArgsDict']]] = None,
                 __props__=None):
        """
        Retrieves a config item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_scm as scm

        example = scm.DecryptionProfile("example")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[str] name: Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Union['DecryptionProfileSslForwardProxyArgs', 'DecryptionProfileSslForwardProxyArgsDict']] ssl_forward_proxy: The SslForwardProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslInboundProxyArgs', 'DecryptionProfileSslInboundProxyArgsDict']] ssl_inbound_proxy: The SslInboundProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslNoProxyArgs', 'DecryptionProfileSslNoProxyArgsDict']] ssl_no_proxy: The SslNoProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslProtocolSettingsArgs', 'DecryptionProfileSslProtocolSettingsArgsDict']] ssl_protocol_settings: The SslProtocolSettings param.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[DecryptionProfileArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Retrieves a config item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_scm as scm

        example = scm.DecryptionProfile("example")
        ```

        :param str resource_name: The name of the resource.
        :param DecryptionProfileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DecryptionProfileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 folder: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 snippet: Optional[pulumi.Input[str]] = None,
                 ssl_forward_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslForwardProxyArgs', 'DecryptionProfileSslForwardProxyArgsDict']]] = None,
                 ssl_inbound_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslInboundProxyArgs', 'DecryptionProfileSslInboundProxyArgsDict']]] = None,
                 ssl_no_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslNoProxyArgs', 'DecryptionProfileSslNoProxyArgsDict']]] = None,
                 ssl_protocol_settings: Optional[pulumi.Input[Union['DecryptionProfileSslProtocolSettingsArgs', 'DecryptionProfileSslProtocolSettingsArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DecryptionProfileArgs.__new__(DecryptionProfileArgs)

            __props__.__dict__["device"] = device
            __props__.__dict__["folder"] = folder
            __props__.__dict__["name"] = name
            __props__.__dict__["snippet"] = snippet
            __props__.__dict__["ssl_forward_proxy"] = ssl_forward_proxy
            __props__.__dict__["ssl_inbound_proxy"] = ssl_inbound_proxy
            __props__.__dict__["ssl_no_proxy"] = ssl_no_proxy
            __props__.__dict__["ssl_protocol_settings"] = ssl_protocol_settings
            __props__.__dict__["tfid"] = None
        super(DecryptionProfile, __self__).__init__(
            'scm:index/decryptionProfile:DecryptionProfile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device: Optional[pulumi.Input[str]] = None,
            folder: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            snippet: Optional[pulumi.Input[str]] = None,
            ssl_forward_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslForwardProxyArgs', 'DecryptionProfileSslForwardProxyArgsDict']]] = None,
            ssl_inbound_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslInboundProxyArgs', 'DecryptionProfileSslInboundProxyArgsDict']]] = None,
            ssl_no_proxy: Optional[pulumi.Input[Union['DecryptionProfileSslNoProxyArgs', 'DecryptionProfileSslNoProxyArgsDict']]] = None,
            ssl_protocol_settings: Optional[pulumi.Input[Union['DecryptionProfileSslProtocolSettingsArgs', 'DecryptionProfileSslProtocolSettingsArgsDict']]] = None,
            tfid: Optional[pulumi.Input[str]] = None) -> 'DecryptionProfile':
        """
        Get an existing DecryptionProfile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: The Device param.
        :param pulumi.Input[str] folder: The Folder param.
        :param pulumi.Input[str] name: Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        :param pulumi.Input[str] snippet: The Snippet param.
        :param pulumi.Input[Union['DecryptionProfileSslForwardProxyArgs', 'DecryptionProfileSslForwardProxyArgsDict']] ssl_forward_proxy: The SslForwardProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslInboundProxyArgs', 'DecryptionProfileSslInboundProxyArgsDict']] ssl_inbound_proxy: The SslInboundProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslNoProxyArgs', 'DecryptionProfileSslNoProxyArgsDict']] ssl_no_proxy: The SslNoProxy param.
        :param pulumi.Input[Union['DecryptionProfileSslProtocolSettingsArgs', 'DecryptionProfileSslProtocolSettingsArgsDict']] ssl_protocol_settings: The SslProtocolSettings param.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DecryptionProfileState.__new__(_DecryptionProfileState)

        __props__.__dict__["device"] = device
        __props__.__dict__["folder"] = folder
        __props__.__dict__["name"] = name
        __props__.__dict__["snippet"] = snippet
        __props__.__dict__["ssl_forward_proxy"] = ssl_forward_proxy
        __props__.__dict__["ssl_inbound_proxy"] = ssl_inbound_proxy
        __props__.__dict__["ssl_no_proxy"] = ssl_no_proxy
        __props__.__dict__["ssl_protocol_settings"] = ssl_protocol_settings
        __props__.__dict__["tfid"] = tfid
        return DecryptionProfile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        The Device param.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def folder(self) -> pulumi.Output[Optional[str]]:
        """
        The Folder param.
        """
        return pulumi.get(self, "folder")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Must start with alphanumeric char and should contain only alphanemeric, underscore, hyphen, dot or space. String validation regex: `^[A-Za-z0-9]{1}[A-Za-z0-9_\\-\\.\\s]{0,}$`.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def snippet(self) -> pulumi.Output[Optional[str]]:
        """
        The Snippet param.
        """
        return pulumi.get(self, "snippet")

    @property
    @pulumi.getter(name="sslForwardProxy")
    def ssl_forward_proxy(self) -> pulumi.Output[Optional['outputs.DecryptionProfileSslForwardProxy']]:
        """
        The SslForwardProxy param.
        """
        return pulumi.get(self, "ssl_forward_proxy")

    @property
    @pulumi.getter(name="sslInboundProxy")
    def ssl_inbound_proxy(self) -> pulumi.Output[Optional['outputs.DecryptionProfileSslInboundProxy']]:
        """
        The SslInboundProxy param.
        """
        return pulumi.get(self, "ssl_inbound_proxy")

    @property
    @pulumi.getter(name="sslNoProxy")
    def ssl_no_proxy(self) -> pulumi.Output[Optional['outputs.DecryptionProfileSslNoProxy']]:
        """
        The SslNoProxy param.
        """
        return pulumi.get(self, "ssl_no_proxy")

    @property
    @pulumi.getter(name="sslProtocolSettings")
    def ssl_protocol_settings(self) -> pulumi.Output[Optional['outputs.DecryptionProfileSslProtocolSettings']]:
        """
        The SslProtocolSettings param.
        """
        return pulumi.get(self, "ssl_protocol_settings")

    @property
    @pulumi.getter
    def tfid(self) -> pulumi.Output[str]:
        return pulumi.get(self, "tfid")

